LBW_Trailer = {};

function LBW_Trailer.prerequisitesPresent(specializations)
    return true;
end;

function LBW_Trailer:load(xmlFile)	
	
	self.PlayerTriggerCallback = LBW_Trailer.PlayerTriggerCallback;
	self.trigger = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.PlayerTrigger#index"));	
	addTrigger(self.trigger, "PlayerTriggerCallback", self);
    self.deleteListenerId = addDeleteListener(self.trigger, "delete", self);

	self.PlayerinTrigger = false;

	self.RotComp = {getWorldRotation(self.components[3].node)};
end;

function LBW_Trailer:delete()
    removeTrigger(self.trigger);
    removeDeleteListener(self.trigger, self.deleteListenerId);
end;

function LBW_Trailer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function LBW_Trailer:keyEvent(unicode, sym, modifier, isDown)
end;

function LBW_Trailer:update(dt)

	local x,y,z = getWorldRotation(self.components[3].node);
	if x ~= self.RotComp[1] or y ~= self.RotComp[2] or z ~= self.RotComp[3] then
		self.RotComp = {x,y,z};
		for _, part in pairs(self.movingParts) do
			part.isDirty = true;
		end;
	end;
	
	if self.PlayerinTrigger == true then 
		
		if InputBinding.hasEvent(InputBinding.LBW_Trailer_1) then
			if self.Upper then
				self:setAnimationTime(1, self.animationParts[1].offSet, false);
			else
				self:setAnimationTime(1, self.animationParts[1].animDuration, false);
			end;
		end;

		if self.Upper then
			g_currentMission:addHelpButtonText(g_i18n:getText("LBW_Trailer_1"), InputBinding.LBW_Trailer_1);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("LBW_Trailer_2"), InputBinding.LBW_Trailer_1);
		end;	
	
	end;
	
	self.Upper = self.animationParts[1].clipEndTime and self.animationParts[1].inputDone;
end;



function LBW_Trailer:updateTick(dt)
 end;
 
function LBW_Trailer:PlayerTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)

	if onEnter or onStay then
		if (g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode) then
			self.PlayerinTrigger = true;
			end;
		elseif onLeave then
			self.PlayerinTrigger = false;
	end;

end;

function LBW_Trailer:onAttach()
	setJointRotationLimit(self.componentJoints[2].jointIndex, 0, true);	
end;

function LBW_Trailer:onDetach()
	setJointRotationLimit(self.componentJoints[2].jointIndex, 0, true);
end;

function LBW_Trailer:draw()
end;
